{% extends 'admin/change_list.html' %}
{% load i18n admin_urls %}

{% block content %}
    <li>
        <a class="historylink" href="csv-download/">Get PKs</a>
        <br/>
        <h3></h3>
        <br/>
    </li>
    <li>
        <a class="historylink" href="import-csv/">Import CSV</a>
        <br/>
        <h3></h3>
        <br/>
    </li>
    <h1>Curation Mechanism Documentation</h1>
    <h2>Introduction</h2>
     The curation mechanism is designed to massively update metadata records stored in the ELG database and, more
     precisely, values of metadata properties that are recorded as rows of models in the database. It can be accessed
     through the Django admin UI, under "Management/Update element values". Within this mechanism there are two main
     functionalities the
     <ul>
         <li>GET PKS</li>
         <li>IMPORT CSV</li>
     </ul>
    explained below
    <h2>GET PKS</h2>
    In order to help retrieve the entity_pk and the appropriate model pk’s, a supportive mechanism is provided
    with the admin page of the curation mechanism. It can be reached by the ‘GET PKS’ button and requires
    <ul>
        <li><b>Metadata record IDs:</b> a list of metadata pks separated by comma</li>
        <li><b>Model:</b> the model name whose instances we would like to retrieve for curation. Values are provided in
            the admin UI as a drop-down list. The user only needs to select the appropriate model.</li>
    </ul>
    The mechanism returns a csv file with the metadata pk, the entity pk, the model pk and all the direct
    fields for that selected model with their values. This way the user can retrieve both the correct name of
    the fields of the model of interest, the required pks for the curation mechanism as well as a view of the
    current values from the db.
    <p>
        <b>NOTE:</b> The retrieve field from the model in the ‘GET PKS’ functionality is NOT the way the curation mechanism
        expects
        its input
    </p>

    <h2>IMPORT CSV</h2>
    <p>
        with the button "IMPORT CSV".
    </p>
    It requires as input:
    <ul>
        <li><b>Action:</b> select among “enrich” or “remove”, meaning whether the provided values will be added/updated
            to existing instances of the selected model or will be removed from them.</li>

        <li><b>Model:</b> the model name whose instances we target to curate. Values are provided in the admin UI as a drop-down list.
            User only needs to select the appropriate model.</li>
        <li><b>CSV file with the following columns:</b>
            <ul>
                <li> <b>entity_pk:</b>: the pk of the main entity that the model we want to curate belongs to,
                    i.e. Language Resource, Project, Organization, Person, Group, License, Document or Repository.
                    <b>ΝΟΤΕ:</b> This is NOT the metadata record pk, as the curation mechanism is designed to work on
                    generic entities as well.</li>
                <li><b>pk:</b> the pk of the instances of the model we want to curate</li>
                <li><b>One column per direct field that belongs to the model we want to curate:</b>
                 As header, we use the field name as declared in the django models.
                </li>
            </ul>
        </li>
    </ul>
    <p>
        <b>ΝΟΤΕ:</b> You can only do removal or enrichment per csv file. You cannot do them simultaneously.
    </p>


    <h2>Enrichment</h2>

    <table>
        <tbody>
        <tr>
            <td><p><strong>Type of field</strong></p></td>
            <td><p><strong>Expected input </strong></p></td>
            <td><p><strong>Expected Behavior</strong></p></td>
            <td><p><strong>Example field</strong></p></td>
            <td><p><strong>Example</strong><strong> value</strong></p></td>
        </tr>
        <tr>
            <td><p>Obligatory multilingual </p></td>
            <td><p>The new value, a simple string</p></td>
            <td><p>Replace existing value for English. Keeps the values for the other languages (if they exist) as they
                are</p></td>
            <td><p>organization_name</p></td>
            <td><p>New Institute for Language and Speech Processing</p></td>
        </tr>
        <tr>
            <td><p>Obligatory multiple multilingual field</p></td>
            <td><p>The new values, simple strings. If multiple values are given, they are separated with |</p></td>
            <td><p>Add new values for English</p></td>
            <td><p>keyword</p></td>
            <td><p>Research|Language Technology|NLP</p></td>
        </tr>
        <tr>
            <td><p>Optional multilingual</p></td>
            <td><p>The new value, a simple string</p></td>
            <td><p>Add new value or replace existing one for English. If values for other languages exist, they are
                kept. </p></td>
            <td><p>licence_terms_short_name </p></td>
            <td><p>CC-0</p></td>
        </tr>
        <tr>
            <td><p>Optional multiple multilingual field</p></td>
            <td><p>The new values, simple strings. If multiple values are given, they are separated with |</p></td>
            <td><p>Add new values for English.</p></td>
            <td><p>organization_short_name</p></td>
            <td><p>ILSP 2 | new ILSP</p></td>
        </tr>
        <tr>
            <td><p>Obligatory text fields (included url/telephone/email)</p></td>
            <td><p>The new value, a simple string</p>

                <p>following the url/telephone/email patterns respectively</p></td>
            <td><p>Replace existing value</p></td>
            <td><p>logo</p></td>
            <td><p><a
                    href="https://encrypted-tbn0.gstatic.com/images?q=tbn:ANd9GcTnCiGVcqFTsdpFkfFlQGKYkURmYh-C9PcvHNZ4Hh4ScHvGVJhsT7YKUmHrbjqCdVo0AEQ&usqp=CAU">https://encrypted-tbn0.gstatic.com/images?q=tbn:ANd9GcTnCiGVcqFTsdpFkfFlQGKYkURmYh-C9PcvHNZ4Hh4ScHvGVJhsT7YKUmHrbjqCdVo0AEQ&usqp=CAU</a>
            </p></td>
        </tr>
        <tr>
            <td><p>Obligatory multiple text fields (included url/telephone/email)</p></td>
            <td><p>The new values, simple string following the url/telephone/email patterns respectively. If multiple
                values are given, they are separated with |</p></td>
            <td><p>Add new values</p></td>
            <td><p>licence_terms_url</p></td>
            <td><p><a href="
                      https://creativecommons.org/public-domain/cc0/|">https://creativecommons.org/public-domain/cc0/|</a>
            </p></td>
        </tr>
        <tr>
            <td><p>Optional single text field (included url/telephone/email)</p></td>
            <td><p>The new value, a simple string</p>

                <p>following the url/telephone/email patterns respectively</p></td>
            <td><p>Add new value (if field is empty) or replace existing</p></td>
            <td><p>mission_statement</p></td>
            <td><p>http://www.google.com</p></td>
        </tr>
        <tr>
            <td><p>Optional multiple text fields (included url/telephone/email)</p></td>
            <td><p>The new values, simple string following the url/telephone/email patterns respectively. If multiple
                values are given, they are separated with |</p></td>
            <td><p>Add new values</p></td>
            <td><p>fax_number</p></td>
            <td><p>(415) 123-4567</p></td>
        </tr>
        <tr>
            <td><p>Obligatory single field with CV</p></td>
            <td><p>The new value from the respective CV</p></td>
            <td><p>Replace existing value</p></td>
            <td><p>currency</p></td>
            <td><p><a href="http://w3id.org/meta-share/meta-share/euro">http://w3id.org/meta-share/meta-share/euro</a>
            </p></td>
        </tr>
        <tr>
            <td><p>Obligatory multiple field with CV</p></td>
            <td><p>The new values from the respective CV. Multiple values are separated with |</p></td>
            <td><p>Add new values</p></td>
            <td><p>condition_of_use</p></td>
            <td><p><a href="http://w3id.org/meta-share/meta-share/academicUseOnly">http://w3id.org/meta-share/meta-share/academicUseOnly</a>
                |<br><a href="http://w3id.org/meta-share/meta-share/researchUse">http://w3id.org/meta-share/meta-share/researchUse</a>
            </p>
            </td>
        </tr>
        <tr>
            <td><p>Optional single field with CV</p></td>
            <td><p>The new value from the respective CV</p></td>
            <td><p>Add new value (if field is empty) or replace existing</p></td>
            <td><p>division_category</p></td>
            <td><p><a href="http://w3id.org/meta-share/meta-share/institute">http://w3id.org/meta-share/meta-share/institute</a>
            </p></td>
        </tr>
        <tr>
            <td><p>Optional multiple field with CV</p></td>
            <td><p>The new values from the respective CV. Multiple values are separated with |</p></td>
            <td><p>Add new values</p></td>
            <td><p>organization_role</p></td>
            <td><p><a
                    href="http://w3id.org/meta-share/meta-share/LTUser">http://w3id.org/meta-share/meta-share/LTUser</a>
                | <a href="http://w3id.org/meta-share/meta-share/consultingFirm">http://w3id.org/meta-share/meta-share/consultingFirm</a>
            </p></td>
        </tr>
        <tr>
            <td><p>Obligatory Date field</p></td>
            <td><p>The new value following the yyyy-mm-dd pattern</p></td>
            <td><p>Replace existing value</p></td>
            <td></td>
            <td></td>
        </tr>
        <tr>
            <td><p>Optional Date field</p></td>
            <td><p>The new value following the yyyy-mm-dd pattern</p></td>
            <td><p>Add new value (if field is empty) or replace existing</p></td>
            <td><p>project_start_date</p></td>
            <td><p>2020-02-02</p></td>
        </tr>
        <tr>
            <td><p>Obligatory Boolean field</p></td>
            <td><p>The new value, either false or true are accepted</p></td>
            <td><p>Replace existing value</p></td>
            <td><p>language_dependent</p></td>
            <td><p>true</p></td>
        </tr>
        <tr>
            <td><p>Optional Boolean field</p></td>
            <td><p>The new value, either false or true are accepted</p></td>
            <td><p>Add new value (if field is empty) or replace existing</p></td>
            <td><p>evaluated</p></td>
            <td><p>false</p></td>
        </tr>
        <tr>
            <td><p>Obligatory One to one relation field</p></td>
            <td><p>The pk of an existing appropriate model</p></td>
            <td><p>Replace existing model</p></td>
            <td><p>lr_subclass</p></td>
            <td><p>30</p></td>
        </tr>
        <tr>
            <td><p>Optional One to one relation field</p></td>
            <td><p>The pk of an existing appropriate model</p></td>
            <td><p>Add new or replace existing</p></td>
            <td><p>head_office_address</p></td>
            <td><p>30</p></td>
        </tr>
        <tr>
            <td><p>Obligatory One to many relation field</p></td>
            <td><p>The pks of existing appropriate models. Multiple values are separated with |</p></td>
            <td><p>Add relations with the models of pks</p></td>
            <td><p>dataset_distribution</p></td>
            <td><p>45 | 59</p></td>
        </tr>
        <tr>
            <td><p>Optional One to many relation field</p></td>
            <td><p>The pks of existing appropriate models. Multiple values are separated with |</p></td>
            <td><p>Add relations with the models of pks</p></td>
            <td><p>other_office_address</p></td>
            <td><p>45 | 99 </p></td>
        </tr>
        </tbody>
    </table>

    <h2>Removal</h2>
    <p>Removal works similar to Enrichment, but instead of adding or replacing the provided values from the respective
        fields, it just removes them.
    </p>
    {{ block.super }}
{% endblock %}